### Virtual Method

# Gio FileEnumerator next_file

#### Declaration

    GFileInfo*
    next_file (
      GFileEnumerator* enumerator,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Returns information for the next file in the enumerated object. Will block until the information is available. The `GFileInfo` returned from this function will contain attributes that match the attribute string that was passed when the `GFileEnumerator` was created.

See the documentation of `GFileEnumerator` for information about the order of returned files.

On error, returns `NULL` and sets `error` to the error. If the enumerator is at the end, `NULL` will be returned and `error` will be unset.

#### Parameters

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFileInfo`

A `GFileInfo` or `NULL` on error or end of enumerator. Free the returned object with `g_object_unref()` when no longer needed.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.